{-# OPTIONS -optc-DPACKAGE_NAME="" #-}
{-# OPTIONS -optc-DPACKAGE_TARNAME="" #-}
{-# OPTIONS -optc-DPACKAGE_VERSION="" #-}
{-# OPTIONS -optc-DPACKAGE_STRING="" #-}
{-# OPTIONS -optc-DPACKAGE_BUGREPORT="" #-}
{-# OPTIONS -optc-DPACKAGE="ginsu" #-}
{-# OPTIONS -optc-DVERSION="0.4.7" #-}
{-# OPTIONS -optc-DHAS_CURSES=1 #-}
{-# OPTIONS -optc-DUSE_NCURSES=1 #-}
{-# OPTIONS -optc-DSTDC_HEADERS=1 #-}
{-# OPTIONS -optc-DHAVE_SYS_TYPES_H=1 #-}
{-# OPTIONS -optc-DHAVE_SYS_STAT_H=1 #-}
{-# OPTIONS -optc-DHAVE_STDLIB_H=1 #-}
{-# OPTIONS -optc-DHAVE_STRING_H=1 #-}
{-# OPTIONS -optc-DHAVE_MEMORY_H=1 #-}
{-# OPTIONS -optc-DHAVE_STRINGS_H=1 #-}
{-# OPTIONS -optc-DHAVE_INTTYPES_H=1 #-}
{-# OPTIONS -optc-DHAVE_STDINT_H=1 #-}
{-# OPTIONS -optc-DHAVE_UNISTD_H=1 #-}
{-# OPTIONS -optc-DHAVE_LIBCRYPTO=1 #-}
{-# OPTIONS -optc-DHAVE_PKG_openssl=1 #-}
{-# OPTIONS -#include <locale.h> #-}
{-# LINE 1 "Locale.hsc" #-}
{-# OPTIONS -ffi #-}
{-# LINE 2 "Locale.hsc" #-}
module Locale(
    -- setlocale stuff
    Locale(..), 
    setLocaleAll, 
    getLocaleAll, 
    setLocale, 
    getLocale,
    -- utf8 versions
    withUTF8String,
    withUTF8StringLen,
    newUTF8String,
    newUTF8StringLen,
    peekUTF8String,
    peekUTF8StringLen
    -- locale versions 

    ) where
import Foreign
import qualified Foreign
import Foreign.C
import qualified Foreign.C as CForeign
import Monad	(liftM)
import Data.Bits
import Char



{-# LINE 29 "Locale.hsc" #-}

{- 
LC_COLLATE
    Affects the behavior of regular expressions and the collation functions.
LC_CTYPE
    Affects the behavior of regular expressions, character classification,
    character conversion functions, and wide-character functions.
LC_MESSAGES
     Affects what strings are expected by commands and utilities as affirmative
     or negative responses.  It also affects what strings are given by commands
     and utilities as affirmative or negative responses, and the content of
     messages. 
LC_MONETARY
    Affects the behavior of functions that handle monetary values.
LC_NUMERIC
    Affects the behavior of functions that handle numeric values.
LC_TIME
    Affects the behavior of the time conversion functi
-}

data Locale = LC_CTYPE | LC_NUMERIC | LC_TIME | LC_COLLATE | LC_MONETARY | LC_MESSAGES | LC_ALL | LC_PAPER | LC_NAME | LC_ADDRESS | LC_TELEPHONE | LC_MEASUREMENT | LC_IDENTIFICATION
    deriving(Show, Enum)

decodeLocale :: Locale -> CInt 
decodeLocale LC_CTYPE = (0)
{-# LINE 54 "Locale.hsc" #-}
decodeLocale LC_NUMERIC = (1)
{-# LINE 55 "Locale.hsc" #-}
decodeLocale LC_COLLATE = (3)
{-# LINE 56 "Locale.hsc" #-}
decodeLocale LC_MONETARY = (4)
{-# LINE 57 "Locale.hsc" #-}
decodeLocale LC_TIME = (2)
{-# LINE 58 "Locale.hsc" #-}

{-# LINE 59 "Locale.hsc" #-}
decodeLocale LC_MESSAGES = (5)
{-# LINE 60 "Locale.hsc" #-}

{-# LINE 61 "Locale.hsc" #-}

{-# LINE 62 "Locale.hsc" #-}
decodeLocale LC_PAPER = (7)
{-# LINE 63 "Locale.hsc" #-}

{-# LINE 64 "Locale.hsc" #-}

{-# LINE 65 "Locale.hsc" #-}
decodeLocale LC_NAME = (8)
{-# LINE 66 "Locale.hsc" #-}

{-# LINE 67 "Locale.hsc" #-}

{-# LINE 68 "Locale.hsc" #-}
decodeLocale LC_ADDRESS = (9)
{-# LINE 69 "Locale.hsc" #-}

{-# LINE 70 "Locale.hsc" #-}

{-# LINE 71 "Locale.hsc" #-}
decodeLocale LC_TELEPHONE = (10)
{-# LINE 72 "Locale.hsc" #-}

{-# LINE 73 "Locale.hsc" #-}

{-# LINE 74 "Locale.hsc" #-}
decodeLocale LC_MEASUREMENT = (11)
{-# LINE 75 "Locale.hsc" #-}

{-# LINE 76 "Locale.hsc" #-}

{-# LINE 77 "Locale.hsc" #-}
decodeLocale LC_IDENTIFICATION = (12)
{-# LINE 78 "Locale.hsc" #-}

{-# LINE 79 "Locale.hsc" #-}
decodeLocale _ = -1

dString :: IO (Ptr CChar) -> IO (Maybe String)
dString action = do 
    v <- action
    if v == nullPtr then return Nothing else fmap Just (peekCString v)

setLocaleAll :: String -> IO (Maybe String)
setLocaleAll s =  dString $ withCString s (setlocale (6))
{-# LINE 88 "Locale.hsc" #-}

getLocaleAll :: IO (Maybe String)
getLocaleAll = getLocale LC_ALL

setLocale :: Locale -> String -> IO (Maybe String)
setLocale l s = case decodeLocale l of
    -1 -> return Nothing
    nl -> dString $ withCString s (setlocale nl)

getLocale :: Locale -> IO (Maybe String)
getLocale l = case decodeLocale l of 
    -1 -> return Nothing
    nl -> dString $ setlocale nl nullPtr 

foreign import ccall unsafe "locale.h setlocale" setlocale :: CInt -> Ptr CChar -> IO (Ptr CChar)



-- CForeign




withUTF8String :: String -> (CString -> IO a) -> IO a
withUTF8String hsStr = CForeign.withCString (toUTF hsStr)

withUTF8StringLen :: String -> (CStringLen -> IO a) -> IO a
withUTF8StringLen hsStr = CForeign.withCStringLen (toUTF hsStr)

newUTF8String :: String -> IO CString
newUTF8String = CForeign.newCString . toUTF

newUTF8StringLen :: String -> IO CStringLen
newUTF8StringLen = CForeign.newCStringLen . toUTF

peekUTF8String :: CString -> IO String
peekUTF8String strPtr = liftM fromUTF $ CForeign.peekCString strPtr

peekUTF8StringLen :: CStringLen -> IO String
peekUTF8StringLen strPtr = liftM fromUTF $ CForeign.peekCStringLen strPtr


-- these should read and write directly from/to memory.
-- A first pass will be needed to determine the size of the allocated region

toUTF :: String -> String
toUTF [] = []
toUTF (x:xs) | ord x<=0x007F = x:toUTF xs
	     | ord x<=0x07FF = chr (0xC0 .|. ((ord x `shift` (-6)) .&. 0x1F)):
			       chr (0x80 .|. (ord x .&. 0x3F)):
			       toUTF xs
	     | otherwise     = chr (0xE0 .|. ((ord x `shift` (-12)) .&. 0x0F)):
			       chr (0x80 .|. ((ord x `shift` (-6)) .&. 0x3F)):
			       chr (0x80 .|. (ord x .&. 0x3F)):
			       toUTF xs

fromUTF :: String -> String
fromUTF [] = []
fromUTF (all@(x:xs)) | ord x<=0x7F = x:fromUTF xs
		     | ord x<=0xBF = err
		     | ord x<=0xDF = twoBytes all
		     | ord x<=0xEF = threeBytes all
		     | otherwise   = err
  where
    twoBytes (x1:x2:xs) = chr (((ord x1 .&. 0x1F) `shift` 6) .|.
			       (ord x2 .&. 0x3F)):fromUTF xs
    twoBytes _ = error "fromUTF: illegal two byte sequence"

    threeBytes (x1:x2:x3:xs) = chr (((ord x1 .&. 0x0F) `shift` 12) .|.
				    ((ord x2 .&. 0x3F) `shift` 6) .|.
				    (ord x3 .&. 0x3F)):fromUTF xs
    threeBytes _ = error "fromUTF: illegal three byte sequence" 
    
    err = error "fromUTF: illegal UTF-8 character"



